""" Half-width and full-width characters mappings.
"""
half_to_full_letter_map = {
    '\uFF71': ('\u30A2', None, None),
    '\uFF72': ('\u30A4', None, None),
    '\uFF73': ('\u30A6', '\u30F4', None),
    '\uFF74': ('\u30A8', None, None),
    '\uFF75': ('\u30AA', None, None),
    '\uFF76': ('\u30AB', '\u30AC', None),
    '\uFF77': ('\u30AD', '\u30AE', None),
    '\uFF78': ('\u30AF', '\u30B0', None),
    '\uFF79': ('\u30B1', '\u30B2', None),
    '\uFF7A': ('\u30B3', '\u30B4', None),
    '\uFF7B': ('\u30B5', '\u30B6', None),
    '\uFF7C': ('\u30B7', '\u30B8', None),
    '\uFF7D': ('\u30B9', '\u30BA', None),
    '\uFF7E': ('\u30BB', '\u30BC', None),
    '\uFF7F': ('\u30BD', '\u30BE', None),
    '\uFF80': ('\u30BF', '\u30C0', None),
    '\uFF81': ('\u30C1', '\u30C2', None),
    '\uFF82': ('\u30C4', '\u30C5', None),
    '\uFF83': ('\u30C6', '\u30C7', None),
    '\uFF84': ('\u30C8', '\u30C9', None),
    '\uFF85': ('\u30CA', None, None),
    '\uFF86': ('\u30CB', None, None),
    '\uFF87': ('\u30CC', None, None),
    '\uFF88': ('\u30CD', None, None),
    '\uFF89': ('\u30CE', None, None),
    '\uFF8A': ('\u30CF', '\u30D0', '\u30D1'),
    '\uFF8B': ('\u30D2', '\u30D3', '\u30D4'),
    '\uFF8C': ('\u30D5', '\u30D6', '\u30D7'),
    '\uFF8D': ('\u30D8', '\u30D9', '\u30DA'),
    '\uFF8E': ('\u30DB', '\u30DC', '\u30DD'),
    '\uFF8F': ('\u30DE', None, None),
    '\uFF90': ('\u30DF', None, None),
    '\uFF91': ('\u30E0', None, None),
    '\uFF92': ('\u30E1', None, None),
    '\uFF93': ('\u30E2', None, None),
    '\uFF94': ('\u30E4', None, None),
    '\uFF95': ('\u30E6', None, None),
    '\uFF96': ('\u30E8', None, None),
    '\uFF97': ('\u30E9', None, None),
    '\uFF98': ('\u30EA', None, None),
    '\uFF99': ('\u30EB', None, None),
    '\uFF9A': ('\u30EC', None, None),
    '\uFF9B': ('\u30ED', None, None),
    '\uFF9C': ('\u30EF', '\u30F7', None),
    '\uFF66': ('\u30F2', '\u30FA', None),
    '\uFF9D': ('\u30F3', None, None),
    '\uFF6C': ('\u30E3', None, None),
    '\uFF6D': ('\u30E5', None, None),
    '\uFF6E': ('\u30E7', None, None),
    '\uFF6F': ('\u30C3', None, None),
    '\uFF67': ('\u30A1', None, None),
    '\uFF68': ('\u30A3', None, None),
    '\uFF69': ('\u30A5', None, None),
    '\uFF6A': ('\u30A7', None, None),
    '\uFF6B': ('\u30A9', None, None),
}

half_to_full_voicing_mark_map = {
    '\uFF9E': '\u309B',
    '\uFF9F': '\u309C',
}

half_to_full_punctuation_map = {
    '\uFF64': '\u3001',
    '\uFF61': '\u3002',
}

half_to_full_corner_bracket_map = {
    '\uFF62': '\u300C',
    '\uFF63': '\u300D',
}

half_to_full_conjunction_mark_map = {
    '\uFF65': '\u30FB',
}

half_to_full_length_mark_map = {
    '\uFF70': '\u30FC',
}

half_to_full_space_map = {
    '\u0020': '\u3000',
    '\u00A0': '\u3000',
}

half_to_full_ascii_symbol_map = {
    '\u0021': '\uFF01',
    '\u0022': '\uFF02',
    '\u0023': '\uFF03',
    '\u0024': '\uFF04',
    '\u0025': '\uFF05',
    '\u0026': '\uFF06',
    '\u0027': '\uFF07',
    '\u0028': '\uFF08',
    '\u0029': '\uFF09',
    '\u002A': '\uFF0A',
    '\u002B': '\uFF0B',
    '\u002C': '\uFF0C',
    '\u002D': '\uFF0D',
    '\u002E': '\uFF0E',
    '\u002F': '\uFF0F',
    '\u003A': '\uFF1A',
    '\u003B': '\uFF1B',
    '\u003C': '\uFF1C',
    '\u003D': '\uFF1D',
    '\u003E': '\uFF1E',
    '\u003F': '\uFF1F',
    '\u0040': '\uFF20',
    '\u005B': '\uFF3B',
    '\u005C': '\uFF3C',
    '\u005D': '\uFF3D',
    '\u005E': '\uFF3E',
    '\u005F': '\uFF3F',
    '\u0060': '\uFF40',
    '\u007B': '\uFF5B',
    '\u007C': '\uFF5C',
    '\u007D': '\uFF5D',
    '\u007E': '\uFF5E',
}

half_to_full_ascii_digit_map = {
    '\u0030': '\uFF10',
    '\u0031': '\uFF11',
    '\u0032': '\uFF12',
    '\u0033': '\uFF13',
    '\u0034': '\uFF14',
    '\u0035': '\uFF15',
    '\u0036': '\uFF16',
    '\u0037': '\uFF17',
    '\u0038': '\uFF18',
    '\u0039': '\uFF19',
}

half_to_full_ascii_alphabet_map = {
    '\u0041': '\uFF21',
    '\u0042': '\uFF22',
    '\u0043': '\uFF23',
    '\u0044': '\uFF24',
    '\u0045': '\uFF25',
    '\u0046': '\uFF26',
    '\u0047': '\uFF27',
    '\u0048': '\uFF28',
    '\u0049': '\uFF29',
    '\u004A': '\uFF2A',
    '\u004B': '\uFF2B',
    '\u004C': '\uFF2C',
    '\u004D': '\uFF2D',
    '\u004E': '\uFF2E',
    '\u004F': '\uFF2F',
    '\u0050': '\uFF30',
    '\u0051': '\uFF31',
    '\u0052': '\uFF32',
    '\u0053': '\uFF33',
    '\u0054': '\uFF34',
    '\u0055': '\uFF35',
    '\u0056': '\uFF36',
    '\u0057': '\uFF37',
    '\u0058': '\uFF38',
    '\u0059': '\uFF39',
    '\u005A': '\uFF3A',
    '\u0061': '\uFF41',
    '\u0062': '\uFF42',
    '\u0063': '\uFF43',
    '\u0064': '\uFF44',
    '\u0065': '\uFF45',
    '\u0066': '\uFF46',
    '\u0067': '\uFF47',
    '\u0068': '\uFF48',
    '\u0069': '\uFF49',
    '\u006A': '\uFF4A',
    '\u006B': '\uFF4B',
    '\u006C': '\uFF4C',
    '\u006D': '\uFF4D',
    '\u006E': '\uFF4E',
    '\u006F': '\uFF4F',
    '\u0070': '\uFF50',
    '\u0071': '\uFF51',
    '\u0072': '\uFF52',
    '\u0073': '\uFF53',
    '\u0074': '\uFF54',
    '\u0075': '\uFF55',
    '\u0076': '\uFF56',
    '\u0077': '\uFF57',
    '\u0078': '\uFF58',
    '\u0079': '\uFF59',
    '\u007A': '\uFF5A',
}

full_to_half_letter_map = {
    **{v[0]: k for k, v in half_to_full_letter_map.items() if v[0] is not None},
    **{v[1]: f'{k}\uFF9E' for k, v in half_to_full_letter_map.items() if v[1] is not None},
    **{v[2]: f'{k}\uFF9F' for k, v in half_to_full_letter_map.items() if v[2] is not None},
}

full_to_half_voicing_mark_map = {
    **{v: k for k, v in half_to_full_voicing_mark_map.items()},
    **{
        '\u3099': '\uFF9E',
        '\u309A': '\uFF9F',
    }
}

full_to_half_punctuation_map = {v: k for k, v in half_to_full_punctuation_map.items()}

full_to_half_corner_bracket_map = {v: k for k, v in half_to_full_corner_bracket_map.items()}

full_to_half_conjunction_mark_map = {v: k for k, v in half_to_full_conjunction_mark_map.items()}

full_to_half_length_mark_map = {v: k for k, v in half_to_full_length_mark_map.items()}

full_to_half_space_map = {
    '\u3000': '\u0020',
}

full_to_half_ascii_symbol_map = {v: k for k, v in half_to_full_ascii_symbol_map.items()}

full_to_half_ascii_digit_map = {v: k for k, v in half_to_full_ascii_digit_map.items()}

full_to_half_ascii_alphabet_map = {v: k for k, v in half_to_full_ascii_alphabet_map.items()}

full_to_half_wave_dash = {
    '\u301C': '\u007E',
}
